/************************************************************************
 *                                                                      *
 *    Copyright (c) 1991 Wilhelm Valder, Regine Freitag, Wolfgang Dzida *
 *                        All rights reserved                           *
 *                                                                      *
 *                                                                      *
 *    Permission to copy this program or any part of this program is    *
 *    granted in case of personal, non-commercial use only. Any use     *
 *    for profit or other commercial gain without written permissions   *
 *    of the authors is prohibited.                                     *
 *                                                                      *
 *    You may freely distribute this program to friends, colleagues,    *
 *    etc.  As a courtesy we would appreciate it if you left our names  *
 *    on the code as the authors.                                       *
 *    We also, of course, disavow any liabilities                       *
 *    for any bizarre things you may choose to do with the system.      *
 *                                                                      *
 *    We would appreciate though your letting us know about any         *
 *    extensions, modifications, project suggestions, etc.              *
 *    Please mail all bugs, comments, complaints and suggestions to:    *
 *                                                                      *
 *                                                                      *
 *    GMD (German National Research Center for Computer Science)        *
 *    Institut fuer Systemtechnik (F2G2)                                *
 *    P.O. Box 1240                                                     *
 *    Schloss Birlinghoven                                              *
 *    D-5205 St. Augustin 1, West Germany                               *
 *                                                                      *
 *    email:    dzida@kmx.gmd.dbp.de                                    *
 *              freitag@gmdzi.uunet                                     *
 *                                                                      *
 ************************************************************************/
#define VERSION "ERGO AED Version 2.0"

#include <signal.h>

#include "aed.h"

static char SccsID[] = "@(#)aed.c	1.2\t1/27/93";            /* sccs keyword */

extern char *getcwd();

main(argc,argv)
     int argc;
     char *argv[];
{
  char *prefix;
  char fullName[512];
  int i, dpyno;
  XEvent event;
  Widget top;
  aedForm *aed_form;
  Display *display;
  int eshErrorHandler();
  char **flist;

  if (argc == 1) {			/* no file given */ 
    sprintf(fullName, "Usage: %s <file1> ....", argv[0]);
    fatal("FileTreeBrowser", fullName, NULL);
  }
  
  top = XtInitialize(NULL, "AED", NULL, 
		          (XrmOptionDescRec *) 0, &argc, argv);

  display = XtDisplay(top);
  dpyno = ConnectionNumber(display);
  XSynchronize(display, True); 
  XSetErrorHandler(eshErrorHandler);

  initAed(display);

  aed_form = exCreateAedForm(top, 100, 100, True);
  
  if (! (prefix = getcwd(NULL, 255)))
    fatal("Cannot pwd !", NULL);

  flist = (char **) calloc(argc - 1, sizeof(char *));

  for (i = 0; i < argc - 1; i++)
    flist[i] = strCopy(argv[i + 1]);
  
  openAed(aed_form, prefix, flist, argc - 1);
  aedInfo(aed_form, 0);

  while (True) {
    XtNextEvent(&event);
    XtDispatchEvent(&event);
  }
}

/*ARGSUSED*/
int eshErrorHandler(dsp, event)
     Display *dsp;
     XErrorEvent *event;
{
  kill(getpid(), SIGQUIT);
}


