#ifndef _exBasics_h_
#define _exBasics_h_

#include <X11/Intrinsic.h>

#ifdef DEBUG
#include <mnemosyne.h>
#endif

/****************************************************************************
 *
 *				basic defintions 
 *
 ****************************************************************************/

struct ptydesc {
	int		pt_pfd;		/* file descriptor of master side */
	int		pt_tfd;		/* file descriptor of slave side */
	char		*pt_pname;	/* master device name */
	char		*pt_tname;	/* slave device name */
};

#ifndef DEBUG
extern char *malloc();
extern char **calloc();
#endif DEBUG

#define EQUAL	0			/* string compare equal */
#ifndef NULL
#define NULL (char *) 0
#endif

#ifndef EOS
#define EOS  '\0'
#endif

#define BYE             return(setError(ERR_NOERR))
#define isNumber(ch) (((ch) <= '9' && (ch) >= '0'))
#define ABS(x)  (((x) < 0) ? -(x) : (x))

#ifndef MIN
#define MIN(v1,v2) (((v1) > (v2)) ? (v2) : (v1))
#endif

#ifndef MAX
#define MAX(v1,v2) (((v1) > (v2)) ? (v1) : (v2))
#endif

#define CLOWER(ch) (((ch) >= 'A' && (ch) <= 'Z') ? (ch) + ' ' : (ch))
#define CUPPER(ch) (((ch) >= 'a' && (ch) <= 'z') ? (ch) - ' ' : (ch))

#define ROUNDOFF(a,b) (((a) % (b)) ? (a) / (b) + 1 : (a) / (b))
#define ROUNDOUT(a,b) (((a) % (b)) ? (a) / (b) - 1 : (a) / (b))
#define ROUNDMOD(a,b) (((a) / (b)) * (b))
#define FROUND(a)  (((a) - (int)(a) < 0.5) ? (int)(a) : (int)((a) + 1))

#ifndef ctrl
#define ctrl(c) 	(c & 037)
#endif

#define SetBit(flag, bit)	((flag) |= (1 << (bit)))
#define TestBit(flag, bit)    ((flag) & (1 << (bit)))

#define Write(fd,buf,size)	if (write((fd),(char *)(buf),(size)) < (size)) \
					return(setError(ERR_WRITE));

#define Read(fd,buf,size)	if (read((fd),(char *)(buf),(size)) < (size)) \
					return(setError(ERR_READ));

#define ReadString(fd,string)   if (readString((fd),(string)) == ERROR) \
					return(ERROR);

/* some constants */

#define EX_MAXSTR	1024   	/* maximal string length */
#define MAXFNAME         127    /* maximal length of a file name */

static char exBasicsSccsID[] = "%W%\t%G%";            /* sccs keyword */

/****************************************************************************
 *
 *				external declarations
 *
 ****************************************************************************/

extern Boolean charInSet(/* c, str */);
extern Boolean emptyStr(/* string */);
extern Boolean fileExists(/* file */);
extern Boolean isDirFile(/* file */);
extern Boolean strCmp(/* str1, str2 */);
extern adjustEnvironment(/* lines, cols, name */);
extern char **Calloc(/* elems,size */);
extern char *Malloc(/* size */);
extern char *convTime(/* clock */);
extern char *makeStr(/* start, end, size */);
extern char *parseStr(/* pat, char1, char2, size */);
extern char *strCopy(/* str */);
extern cleanPath(/* new, old, size */);
extern cntCharInStr(/* chr, str */);
extern convertRegExp(/* rexp, shellRexp */);
extern exExpand(/* WorkDir, Pat, Buf, sizeofbuf */);
extern exParsePath(/* path, prefix, textBuf, textBufSize */);
extern exReceiveMsg(/* fd, id, opc, info */);
extern exSendMsg(/* fd, id, opc, info */);
extern exSendName(/* fd, id, name */);
extern exWait(/* ticks */);
extern expand_name(/* n, len */);
extern fformatText(/* text, length, ftext */);
extern int exFormat(/* buffer, lines, maxlen, Offset, result, justify */);
extern int getFileSize(/* file */);
extern int loadDirectory(/* directory, table, size */);
extern int makeStringList(/* buffer, list, cnt, del */);
extern int power(/* x, y */);
extern int touchFile(/* file, a_time, u_time */);
extern makeFullName(/* dir, file, fullName, len */);
extern openpty(/* pt */) ;
extern readString(/* fd, string */);
extern removeCtrlTerminal();
extern sortStringList(/* list, cnt */);
extern void exError(/* va_alist */);
extern void fatal(/* va_alist */);
extern void setBit(/* mask, bit, setreset */);
extern void setMask(/* m, cnt, setreset */);
extern void setWinSize(/* tty, lines, cols */);
extern void ttyGet();
extern void ttySet(/* tty */);
extern writeString(/* fd,string */);
#endif
